# generated by datamodel-codegen:
#   filename:  context.json
#   timestamp: 2025-01-27T15:24:27+00:00

from __future__ import annotations

from typing import Optional

from pydantic import AnyUrl, BaseModel, EmailStr, Field


class Context(BaseModel):
    title: Optional[str] = Field(
        None,
        description='A title of the associated project.',
        examples=['NFDI4Energy'],
        title='Context Title',
    )
    homepage: Optional[AnyUrl] = Field(
        None,
        description='A URL of the project.',
        examples=['https://nfdi4energy.uol.de/'],
        title='Homepage',
    )
    documentation: Optional[str] = Field(
        None,
        description='A URL of the project documentation.',
        examples=['https://nfdi4energy.uol.de/sites/about_us/'],
        title='Documentation',
    )
    sourceCode: Optional[str] = Field(
        None,
        description='A URL of the source code of the project.',
        examples=['https://github.com/NFDI4Energy'],
        title='Source Code',
    )
    publisher: Optional[str] = Field(
        None,
        description='The publishing agency of the data. This can be the OEP.',
        examples=['Open Energy Platform (OEP)'],
        title='Publisher',
    )
    publisherLogo: Optional[AnyUrl] = Field(
        None,
        description='A URL to the logo of the publishing agency of data.',
        examples=[
            'https://github.com/OpenEnergyPlatform/organisation/blob/production/logo/OpenEnergyFamily_Logo_OpenEnergyPlatform.svg'
        ],
        title='Publisher Logo',
    )
    contact: Optional[EmailStr] = Field(
        None,
        description='A reference to the creator or maintainer of the data set. This can be an email address or a GitHub handle.',
        examples=['contact@example.com'],
        title='E-Mail Contact',
    )
    fundingAgency: Optional[str] = Field(
        None,
        description='A name of the entity providing the funding. This can be a government agency or a company.',
        examples=[' Deutsche Forschungsgemeinschaft (DFG)'],
        title='Funding Agency',
    )
    fundingAgencyLogo: Optional[AnyUrl] = Field(
        None,
        description='A URL to the logo or image of the funding agency.',
        examples=[
            'https://upload.wikimedia.org/wikipedia/commons/8/86/DFG-logo-blau.svg'
        ],
        title='Funding Agency Logo',
    )
    grantNo: Optional[str] = Field(
        None,
        description='An identifying grant number. In case of a publicly funded project, this number is assigned by the funding agency.',
        examples=['501865131'],
        title='Grant Number',
    )


class Model(BaseModel):
    context: Optional[Context] = Field(
        None,
        description='An Object that describes the general setting, environment or project leading to the creation or maintenance of this dataset. In science this can be the research project.',
        title='Context',
    )
