# generated by datamodel-codegen:
#   filename:  licenses.json
#   timestamp: 2025-01-27T15:25:21+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import AnyUrl, BaseModel, Field


class License(BaseModel):
    name: Optional[str] = Field(
        None, description='The SPDX identifier.', example='ODbL-1.0', title='Name'
    )
    title: Optional[str] = Field(
        None,
        description='The official (human readable) title of the license.',
        example='Open Data Commons Open Database License 1.0',
        title='Title',
    )
    path: Optional[AnyUrl] = Field(
        None,
        description='A link or path to the license text.',
        example='https://opendatacommons.org/licenses/odbl/1-0/index.html',
        title='Path',
    )
    instruction: Optional[str] = Field(
        None,
        description='A short description of rights and obligations. The use of tl;drLegal is recommended.',
        example='You are free to share and change, but you must attribute, and share derivations under the same license. See https://tldrlegal.com/license/odc-open-database-license-(odbl) for further information.',
        title='Instruction',
    )
    attribution: Optional[str] = Field(
        None,
        description='A copyright holder of the data. Must be provided if attribution licenses are used.',
        example='© Reiner Lemoine Institut',
        title='Attribution',
    )


class Model(BaseModel):
    licenses: Optional[List[License]] = Field(
        None,
        description='An array of objects of licenses under which the described data is provided.',
        title='Licenses',
    )
