# generated by datamodel-codegen:
#   filename:  provenance.json
#   timestamp: 2025-01-27T15:28:56+00:00

from __future__ import annotations

from datetime import date
from typing import List, Optional

from pydantic import BaseModel, Field


class Contributor(BaseModel):
    title: Optional[str] = Field(
        None,
        description='A full name of the contributor.',
        examples=['Ludwig Hülk'],
        title='Contributor Title',
    )
    path: Optional[str] = Field(
        None,
        description='A qualified link or path pointing to a relevant location online for the contributor. This can be the GitHub page or ORCID.',
        examples=['https://github.com/Ludee'],
        title='Path',
    )
    organization: Optional[str] = Field(
        None,
        description='A string describing the organization this contributor is affiliated to. This can be relevant for the copyright.',
        examples=['Reiner Lemoine Institut'],
        title='Organization',
    )
    roles: Optional[List[Optional[str]]] = Field(
        None,
        description='An array describing the roles of the contributor.',
        title='Roles',
    )
    date_: Optional[date] = Field(
        None,
        description='The date of the final contribution. Date Format is ISO 8601.',
        examples=['2024-10-21'],
        title='Date',
    )
    object: Optional[str] = Field(
        None,
        description='The object of the contribution. Which part of the package was supplied or changed.',
        examples=['data and metadata'],
        title='Object',
    )
    comment: Optional[str] = Field(
        None,
        description='A free-text commentary on what has been done.',
        examples=['Add metadata example.'],
        title='Comment',
    )


class Model(BaseModel):
    contributors: Optional[List[Contributor]] = Field(
        None,
        description='An array of objects of contributors and contributions to the data or metadata.',
        title='Contributors',
    )
