# generated by datamodel-codegen:
#   filename:  sources.json
#   timestamp: 2025-01-27T15:30:05+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import AnyUrl, BaseModel, Field


class SourceLicense(BaseModel):
    name: Optional[str] = Field(
        None, description='The SPDX identifier.', examples=['ODbL-1.0'], title='Name'
    )
    title: Optional[str] = Field(
        None,
        description='The official (human readable) title of the license.',
        examples=['Open Data Commons Open Database License 1.0'],
        title='Title',
    )
    path: Optional[AnyUrl] = Field(
        None,
        description='A link or path to the license text.',
        examples=['https://opendatacommons.org/licenses/odbl/1-0/index.html'],
        title='License Identifier',
    )
    instruction: Optional[str] = Field(
        None,
        description='A short description of rights and obligations. The use of tl;drLegal is recommended.',
        examples=[
            'You are free to share and change, but you must attribute, and share derivations under the same license. See https://tldrlegal.com/license/odc-open-database-license-odbl for further information.'
        ],
        title='Instruction',
    )
    attribution: Optional[str] = Field(
        None,
        description='A copyright owner of the source. Must be provided if attribution licenses are used.',
        examples=['© Intergovernmental Panel on Climate Change 2023'],
        title='Attribution',
    )
    copyrightStatement: Optional[str] = Field(
        None,
        description='A link or path that proves that the source or data has the appropriate license. This can be a page number or website imprint.',
        examples=['https://www.ipcc.ch/copyright/'],
        title='Copyright Statement',
    )


class Source(BaseModel):
    title: Optional[str] = Field(
        None,
        description='A human readable title of the source, a document title or organisation name.',
        examples=[
            'IPCC Sixth Assessment Report (AR6) - Climate Change 2023 - Synthesis Report'
        ],
        title='Source Title',
    )
    authors: Optional[List[Optional[str]]] = Field(
        None,
        description='An array of the full names of the authors of the source material.',
        title='Keywords',
    )
    description: Optional[str] = Field(
        None,
        description='A free text description of the source.',
        examples=['A Report of the Intergovernmental Panel on Climate Change.'],
        title='Source Description',
    )
    publicationYear: Optional[str] = Field(
        None,
        description='Indicates the year when the work was published.',
        examples=['2023'],
        title='Publication Year',
    )
    field_id: Optional[AnyUrl] = Field(
        None,
        alias='@id',
        description='A URL to the original source.',
        examples=[
            'https://www.ipcc.ch/report/ar6/syr/downloads/report/IPCC_AR6_SYR_FullVolume.pdf'
        ],
        title='Source Identifier',
    )
    sourceLicenses: Optional[List[SourceLicense]] = Field(None, title='Licenses')


class Model(BaseModel):
    sources: Optional[List[Source]] = Field(
        None,
        description='An array of objects with the used and underlying sources of the data and metadata.',
        title='Sources',
    )
