# generated by datamodel-codegen:
#   filename:  spatial.json
#   timestamp: 2025-01-27T15:27:16+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import AnyUrl, BaseModel, Field


class Location(BaseModel):
    address: Optional[str] = Field(
        None,
        description='An address of the location of the data. May be specified with street name, house number, zip code, and city name.',
        examples=['Rudower Chaussee 12, 12489 Berlin'],
        title='Address',
    )
    field_id: Optional[str] = Field(
        None,
        alias='@id',
        description='A path or URI to a specific location. It can use Wikidata or OpenStreetMap.',
        examples=['https://www.wikidata.org/wiki/Q77077223'],
        title='Address Identifier',
    )
    latitude: Optional[str] = Field(
        None,
        description='The latitude (lat) information of the location. Specifies the north / south position of the geometry.',
        examples=['52.432822'],
        title='Latitude',
    )
    longitude: Optional[str] = Field(
        None,
        description='The longitude (lon) information of the location. Specifies the east / west position of the geometry.',
        examples=['13.5351004'],
        title='Longitude',
    )


class Extent(BaseModel):
    name: Optional[str] = Field(
        None,
        description='The name of the region.',
        examples=['Berlin'],
        title='Extent Name',
    )
    field_id: Optional[AnyUrl] = Field(
        None,
        alias='@id',
        description='A URI reference for the region.',
        examples=['https://www.wikidata.org/wiki/Q64'],
        title='Extent Identifier',
    )
    resolutionValue: Optional[str] = Field(
        None,
        description='The value of the resolution.',
        examples=['100'],
        title='Resolution Value',
    )
    resolutionUnit: Optional[str] = Field(
        None,
        description='The unit of the resolution.',
        examples=['m'],
        title='Resolution Unit',
    )
    boundingBox: Optional[List[float]] = Field(
        None,
        description='The covered area specified by the coordinates of a bounding box. The format is [minLon, minLat, maxLon, maxLat] or [W,S,E,N].',
        examples=[13.08825, 52.33859, 13.76104, 52.6754],
        max_items=4,
        min_items=4,
        title='Bounding Box',
    )
    crs: Optional[str] = Field(
        None,
        description='The Coordinate Reference System, specified as an EPSG code.',
        examples=['EPSG:4326'],
        title=' Coordinate Reference System (CRS)',
    )


class Spatial(BaseModel):
    location: Optional[Location] = Field(
        None,
        description='An object that describes a covered area or region.',
        title='Extent',
    )
    extent: Optional[Extent] = Field(
        None,
        description='An object that describes a covered area or region.',
        title='Extent',
    )


class Model(BaseModel):
    spatial: Optional[Spatial] = Field(
        None,
        description='An object that describes the spatial context of the data.',
        title='Spatial',
    )
