# generated by datamodel-codegen:
#   filename:  temporal.json
#   timestamp: 2025-01-27T15:30:28+00:00

from __future__ import annotations

from datetime import date, datetime
from typing import List, Optional

from pydantic import BaseModel, Field


class Timesery(BaseModel):
    start: Optional[datetime] = Field(
        None,
        description='The start time of a time series.',
        examples=['2020-01-01T00:00:00+00:00'],
        title='Timeseries Start',
    )
    end: Optional[datetime] = Field(
        None,
        description='The temporal end point of a time series.',
        examples=['2020-01-01T23:59:30+00:00'],
        title='Timeseries End',
    )
    resolution: Optional[str] = Field(
        None,
        description='The time span between individual information points in a time series.',
        examples=['30 s'],
        title='Timeseries Resolution',
    )
    alignment: Optional[str] = Field(
        None,
        description='An indicator of whether timestamps in a time series are to the left, right or in the centre.',
        examples=['left'],
        title='Timeseries Alignment',
    )
    aggregationType: Optional[str] = Field(
        None,
        description='An indicator of whether the values are a sum, an average or a current value.',
        examples=['current'],
        title='Timeseries Aggregation Type',
    )


class Temporal(BaseModel):
    referenceDate: Optional[date] = Field(
        None,
        description='A base year, month or day. The time for which the data is should be accurate. Date Format is ISO 8601.',
        examples=['2020-01-01'],
        title='Reference Date',
    )
    timeseries: Optional[List[Timesery]] = Field(
        None, description='An array that describe the timeseries.', title='Timeseries'
    )


class Model(BaseModel):
    temporal: Optional[Temporal] = Field(
        None,
        description='An object with the time period covered in the data. Temporal information should contain either a "referenceDate" or the keys that describe a time series, in rare cases both.',
        title='Temporal',
    )
