# generated by datamodel-codegen:
#   filename:  general.json
#   timestamp: 2025-02-04T16:03:37+00:00

from __future__ import annotations

from datetime import date
from typing import List, Optional

from pydantic import AnyUrl, BaseModel, Field


class SubjectItem(BaseModel):
    name: Optional[str] = Field(
        None,
        description='A class label of the ontology term.',
        examples=['energy'],
        title='Subject Name',
    )
    field_id: Optional[AnyUrl] = Field(
        None,
        alias='@id',
        description='A unique identifier (URI/IRI) of the ontology class.',
        examples=['https://openenergyplatform.org/ontology/oeo/OEO_00000150'],
        title='Subject Identifier',
    )


class EmbargoPeriod(BaseModel):
    start: Optional[date] = Field(
        None,
        description='The start date of the embargo period. The date of the data (metadata) upload.',
        examples=['2024-10-11'],
        title='Embargo Period Start',
    )
    end: Optional[date] = Field(
        None,
        description='The end date of the embargo period. This is the intended publication date.',
        examples=['2025-01-01'],
        title='Embargo Period End (Publication Date)',
    )
    isActive: Optional[bool] = Field(
        None,
        description='A boolean key that indicates if the embargo period is currently active. Must be changed to False on the embargo period end date.',
        examples=[True],
        title='Embargo Period is Active ',
    )


class General(BaseModel):
    field_id: Optional[str] = Field(
        None,
        alias='@id',
        description='A Uniform Resource Identifier (URI) that links the resource via the OpenEnergyDatabus (DBpedia Databus).',
        examples=[
            'https://databus.openenergyplatform.org/oeplatform/supply/wri_global_power_plant_database/2022-11-07'
        ],
        title='@Id',
    )
    name: Optional[str] = Field(
        ...,
        description='A filename or database conform table name.',
        examples=['oemetadata_table_template'],
        title='Name',
    )
    topics: Optional[List[Optional[str]]] = Field(
        None,
        description='An array of predefined topics that correspond to the database schemas of the OEP.',
        title='Topics',
    )
    title: Optional[str] = Field(
        None,
        description='A human readable table name.',
        examples=['OEMetadata Table Template'],
        title='Title',
    )
    path: Optional[str] = Field(
        None,
        description='A unique identifier (URI/UUID/DOI) for the table or file.',
        examples=[
            'http://openenergyplatform.org/dataedit/view/model_draft/oemetadata_table_template'
        ],
        title='Path',
    )
    description: Optional[str] = Field(
        None,
        description='A description of the table. It should be usable as summary information for the table that is described by the metadata.',
        examples=[
            'Example table used to illustrate the OEMetadata structure and features.'
        ],
        title='Description',
    )
    languages: Optional[List[Optional[str]]] = Field(
        None,
        description='An array of languages used within the described data structures (e.g. titles, descriptions) or metadata.',
        title='Languages',
    )
    subject: Optional[List[SubjectItem]] = Field(
        None,
        description='An array of objects that references to the subjects of the resource in ontology terms.',
        title='Subject',
    )
    keywords: Optional[List[Optional[str]]] = Field(
        None,
        description='An array of freely selectable keywords that help with searching and structuring.',
        title='Keywords',
    )
    publicationDate: Optional[date] = Field(
        None,
        description='A date of publication of the data or metadata. The date format is ISO 8601 (YYYY-MM-DD).',
        examples=['2024-10-15'],
        title='Publication Date',
    )
    embargoPeriod: Optional[EmbargoPeriod] = Field(
        None,
        description='An object that describes the embargo period during which public access to the data is not allowed.',
        title='Embargo Period',
    )
