# generated by datamodel-codegen:
#   filename:  licenses.json
#   timestamp: 2025-02-04T16:03:37+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import AnyUrl, BaseModel, Field


class License(BaseModel):
    name: Optional[str] = Field(
        None, description='The SPDX identifier.', examples=['ODbL-1.0'], title='Name'
    )
    title: Optional[str] = Field(
        None,
        description='The official (human readable) title of the license.',
        examples=['Open Data Commons Open Database License 1.0'],
        title='Title',
    )
    path: Optional[AnyUrl] = Field(
        None,
        description='A link or path to the license text.',
        examples=['https://opendatacommons.org/licenses/odbl/1-0/index.html'],
        title='Path',
    )
    instruction: Optional[str] = Field(
        None,
        description='A short description of rights and obligations. The use of tl;drLegal is recommended.',
        examples=[
            'You are free to share and change, but you must attribute, and share derivations under the same license. See https://tldrlegal.com/license/odc-open-database-license-(odbl) for further information.'
        ],
        title='Instruction',
    )
    attribution: Optional[str] = Field(
        None,
        description='A copyright holder of the data. Must be provided if attribution licenses are used.',
        examples=['© Reiner Lemoine Institut'],
        title='Attribution',
    )
    copyrightStatement: Optional[str] = Field(
        None,
        description='A link or path that proves that the source or data has the appropriate license. This can be a page number or website imprint.',
        examples=[
            'https://github.com/OpenEnergyPlatform/oemetadata/blob/develop/LICENSE.txt'
        ],
        title='Copyright Statement',
    )


class Licenses(BaseModel):
    licenses: Optional[List[License]] = Field(
        None,
        description='An array of objects of licenses under which the described data is provided.',
        title='Licenses',
    )
