# generated by datamodel-codegen:
#   filename:  meta.json
#   timestamp: 2025-02-04T16:03:38+00:00

from __future__ import annotations

from typing import Optional

from pydantic import AnyUrl, BaseModel, Field


class MetadataLicense(BaseModel):
    name: Optional[str] = Field(
        None,
        description='The SPDX identifier.',
        examples=['CC0-1.0'],
        title='License Name',
    )
    title: Optional[str] = Field(
        None,
        description='The official (human readable) title of the license.',
        examples=['Creative Commons Zero v1.0 Universal'],
        title='License Title',
    )
    path: Optional[AnyUrl] = Field(
        None,
        description='A link or path to the license text.',
        examples=['https://creativecommons.org/publicdomain/zero/1.0'],
        title='License Path',
    )


class MetaMetadata(BaseModel):
    metadataVersion: Optional[str] = Field(
        None,
        description='Type and version number of the metadata.',
        examples=['OEMetadata-2.0.1'],
        title='Metadata Version',
    )
    metadataLicense: Optional[MetadataLicense] = Field(
        None, description='The license of the OEMetadata. ', title='Metadata License'
    )


class Meta(BaseModel):
    metaMetadata: Optional[MetaMetadata] = Field(
        None,
        description='An object that describes the metadata themselves, their format, version and license.',
        title='Meta Metadata',
    )
